osl::eval::ml::MajorCheckWithCapture Class Reference

`#include <majorPiece.h>`

## Public Types

enum | { ONE_DIM = PTYPE_SIZE * 2 * 2 , DIM = ONE_DIM * EvalStages }

## Public Member Functions

template<osl::Player Owner>
osl::MultiInt | addOne (const NumEffectState &state)

## Static Public Member Functions

static void | setUp (const Weights &weights)
static MultiInt | eval (const NumEffectState &state)

## Static Private Member Functions

template<Player Owner>
static MultiInt | addOne (const NumEffectState &state)
static size_t | index (Ptype ptype, bool is_rook, bool can_promote)

## Static Private Attributes

static CArray< MultiInt, ONE_DIM > | table

## Detailed Description

Definition at line 633 of file majorPiece.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 636 of file majorPiece.h.

## Member Function Documentation

## addOne() [1/2]

template<osl::Player Owner>

osl::MultiInt osl::eval::ml::MajorCheckWithCapture::addOne | ( | const NumEffectState & | state | ) |

Definition at line 1219 of file majorPiece.cc.

References osl::alt(), osl::PieceMask::any(), osl::BISHOP, osl::BLACK, osl::Square::canPromote(), osl::NumEffectState::effectedMask(), osl::NumEffectState::hasEffectIf(), osl::NumEffectState::hasLongEffectAt(), index(), osl::SimpleState::kingSquare(), osl::newPtypeO(), osl::SimpleState::pieceOf(), osl::NumEffectState::piecesOnBoard(), osl::Piece::ptype(), osl::ROOK, osl::Piece::square(), table, and osl::container::PieceMask64::takeOneBit().

## addOne() [2/2]

template<Player Owner>

MultiInt osl::eval::ml::MajorCheckWithCapture::addOne | ( | const NumEffectState & | state | ) |

static private

Referenced by eval().

## eval()

osl::MultiInt osl::eval::ml::MajorCheckWithCapture::eval | ( | const NumEffectState & | state | ) |

static

Definition at line 1248 of file majorPiece.cc.

References addOne().

Referenced by osl::eval::ml::OpenMidEndingEval::debugInfo(), osl::eval::ml::OpenMidEndingEval::OpenMidEndingEval(), and osl::eval::ml::OpenMidEndingEval::updateSub().

## index()

size_t osl::eval::ml::MajorCheckWithCapture::index | ( | Ptype | ptype,
|  | bool | is_rook,
|  | bool | can_promote )

inline static private

Definition at line 646 of file majorPiece.h.

Referenced by addOne().

## setUp()

void osl::eval::ml::MajorCheckWithCapture::setUp | ( | const Weights & | weights | ) |

static

Definition at line 1208 of file majorPiece.cc.

References osl::NStages, ONE_DIM, table, and osl::eval::ml::Weights::value().

## Member Data Documentation

## table

osl::CArray< MultiInt, osl::eval::ml::MajorCheckWithCapture::ONE_DIM > osl::eval::ml::MajorCheckWithCapture::table

static private

Definition at line 643 of file majorPiece.h.

Referenced by addOne(), and setUp().

The documentation for this class was generated from the following files:

- majorPiece.h
- majorPiece.cc